#include <Wt/WApplication>
#include <Wt/WLabel>
#include <Wt/WLineEdit>
#include <Wt/WPushButton>
#include <Wt/WText>

#include "wresourcepage.h"


using namespace std;
using namespace Wt;

DefaultPage::DefaultPage(Wt::WString const &defaultMessage) :
dDefaultMessage(nullptr), 
dResourceUrl(nullptr),
dUrlIn(nullptr),
dClearButton(nullptr),
dOutButton(nullptr),
dResourceButton(nullptr),
dWebResource(nullptr)
{

	new WBreak(this);
	new WBreak(this);
	dDefaultMessage = new WText(this);
	dDefaultMessage->setMargin(30, Side::Top | Side::Left);
	dDefaultMessage->setText(defaultMessage);
	new WBreak(this);
	new WBreak(this);
	dResourceUrl = new WText(this);
	dResourceUrl->setMargin(50, Side::Top | Side::Left);
	new WBreak(this);
	new WBreak(this);
	WLabel *urlLabel = new WLabel("Url to Jump in   > ", this);
	urlLabel->setMargin(20, Side::Top | Side::Left);
	dUrlIn = new WLineEdit(this);
	dUrlIn->setMargin(5, Side::Left);
	dUrlIn->setTextSize(40);
	dUrlIn->setMaxLength(64);
	urlLabel->setBuddy(dUrlIn);
	new WBreak(this);
	new WBreak(this);
	dClearButton = new WPushButton("Clear", this);
	dClearButton->setMargin(45, Side::Top | Side::Left);
	dClearButton->clicked().connect(this, &DefaultPage::ClearData);
	dLoadData = new WPushButton("Load", this);
	dLoadData->setMargin(30, Side::Left);
	dLoadData->clicked().connect(this, &DefaultPage::LoadData);
	dResourceButton = new WPushButton("Activate Resource", this);
	dResourceButton->setMargin(30, Side::Left);
	dWebResource = new WebResourceWidget();
	WLink theLink(dWebResource);
	theLink.setTarget(TargetNewWindow);
	dResourceButton->setLink(theLink);
	dResourceButton->setDisabled(true);
	dResourceUrl->setText(dWebResource->GetResourceUrl());
	dOutButton = new WPushButton("Exit", this);
	dOutButton->setMargin(30, Side::Left);
	dOutButton->clicked().connect(this, &DefaultPage::QuitApplication);
	new WBreak(this);
	new WBreak(this);
	dStatusMessage = new WText(this);
	dStatusMessage->setMargin(50, Side::Top | Side::Left);
	dStatusMessage->setStyleClass("staticTitleMsg");

}


void DefaultPage::ClearData(void)
{

	dUrlIn->setText("");
	dStatusMessage->setText("");
	dResourceButton->setDisabled(true);

}


void DefaultPage::LoadData(void)
{

	string theUrl(dUrlIn->text().toUTF8());
	if (theUrl.length()) {
		dStatusMessage->setText("Ready to jump ...");
		dWebResource->SetUrl(theUrl);
		dResourceButton->setDisabled(false);
	}
	else
		dStatusMessage->setText("Need to enter and load at least the URL value to jump ...");

}


void DefaultPage::QuitApplication(void)
{

	clear();
	WApplication::instance()->quit();

}


DefaultPage::~DefaultPage(void)
{

	clear();
	delete dWebResource;

}